# coding: utf-8

"""
    YNAB API Endpoints

    Our API uses a REST based design, leverages the JSON data format, and relies upon HTTPS for transport. We respond with meaningful HTTP response codes and if an error occurs, we include error details in the response body.  API Documentation is at https://api.ynab.com

    The version of the OpenAPI document: 1.75.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from ynab.models.budget_summary import BudgetSummary
from typing import Optional, Set
from typing_extensions import Self

class BudgetSummaryResponseData(BaseModel):
    """
    BudgetSummaryResponseData
    """ # noqa: E501
    budgets: List[BudgetSummary]
    default_budget: Optional[BudgetSummary] = None
    __properties: ClassVar[List[str]] = ["budgets", "default_budget"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BudgetSummaryResponseData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in budgets (list)
        _items = []
        if self.budgets:
            for _item_budgets in self.budgets:
                if _item_budgets:
                    _items.append(_item_budgets.to_dict())
            _dict['budgets'] = _items
        # override the default output from pydantic by calling `to_dict()` of default_budget
        if self.default_budget:
            _dict['default_budget'] = self.default_budget.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BudgetSummaryResponseData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "budgets": [BudgetSummary.from_dict(_item) for _item in obj["budgets"]] if obj.get("budgets") is not None else None,
            "default_budget": BudgetSummary.from_dict(obj["default_budget"]) if obj.get("default_budget") is not None else None
        })
        return _obj


